#include <stdio.h>
#include <stdlib.h>
#include <string.h> // strlen
#include "lutil.h" // from openldap

// Tests OpenLDAP's base64 encoder

int main(int argc, const char** argv) {
	if (argc <= 1) {
		fprintf(stderr, "Usage: %s text\n", argv[0]);
		exit(2);
	}
	int len=strlen(argv[1]);
	int hashlen=LUTIL_BASE64_ENCODE_LEN(len)+1; // +1 for \0
	char hash[hashlen];
	int c = lutil_b64_ntop((u_char const*)argv[1], len, hash, hashlen);
	if (c == -1) {
		fprintf(stderr, "Incorrect result size passed to base64 function (returned: %d)\n", c);
		exit(1);
	}
	printf("%s\n", hash);
	exit(0);
}
